SystemOrganization addCategory: #GLASS!

Object subclass: #FlightInfo
	instanceVariableNames: 'when price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GLASS'!

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:54'!
addHours: anInteger

	when := when + (Duration hours: anInteger).
	self calculatePrice.! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:46'!
calculatePrice

	| hours |
	hours := when asSeconds // 3600.
	price := (hours degreeSin asScaledDecimal: 2) * 30 + 300.! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 16:00'!
initialize

	when := DateAndTime noon + (Duration days: 5).
	self calculatePrice.! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:41'!
price

	^price.! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:58'!
printOn: aStream

	when printYMDOn: aStream.
	aStream space.
	when printHMSOn: aStream.
	aStream skip: -3.
	aStream nextPutAll: ' $'.
	price printOn: aStream.
	aStream skip: -2.
	! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:41'!
when

	^when.! !

!FlightInfo methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 15:52'!
when: aDateAndTime

	when := aDateAndTime.
	self calculatePrice.! !

WAComponent subclass: #FlightInfoComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GLASS'!

!FlightInfoComponent methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 16:20'!
initialize

	super initialize.
	model := FlightInfo new.! !

!FlightInfoComponent methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 17:05'!
renderContentOn: html

	html heading: model.
	html anchor
		callback: [model addHours: -30];
		with: '<- Earlier'.! !

!FlightInfoComponent methodsFor: 'rendering' stamp: 'Jorge 11/3/2012 17:11'!
style 
	^ 'h1 { background: white;}'! !

!FlightInfoComponent methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 16:25'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Flight Information'.! !

WAComponent subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GLASS'!

!HelloWorld methodsFor: 'as yet unclassified' stamp: 'Jorge 11/3/2012 12:24'!
renderContentOn: html
	"comment stating purpose of message"

	| now |
	now := DateAndTime  now.
	html
		heading: 'Hello world!! ';
		heading:  now level: 3;
		yourself.! !
